diff --git a/base/deploy/src/pkispawn b/base/deploy/src/pkispawn
index a48a475..2ac21a6 100755
--- a/base/deploy/src/pkispawn
+++ b/base/deploy/src/pkispawn
@@ -23,15 +23,16 @@
 import sys
 if not hasattr(sys, "hexversion") or sys.hexversion < 0x020700f0:
     print "Python version %s.%s.%s is too old." % sys.version_info[:3]
-    print "Please upgrade to at least Python 2.7.0." 
+    print "Please upgrade to at least Python 2.7.0."
     sys.exit(1)
 try:
     import argparse
     import logging
     import os
     import pprint
+    from time import strftime as date
     from pki.deployment import pkiconfig as config
-    from pki.deployment import pkihelper
+    from pki.deployment import pkiparser as parse
     from pki.deployment import pkilogging
     from pki.deployment import pkimessages as log
 except ImportError:
@@ -55,40 +56,49 @@ def main(argv):
     # Set the umask
     os.umask(config.PKI_DEPLOYMENT_DEFAULT_UMASK)
 
+    # Generate a timestamp
+    config.pki_timestamp = date('%Y%m%d%H%M%S')
+
     # Initialize 'pretty print' for objects
     pp = pprint.PrettyPrinter(indent=4)
 
     # Read and process command-line arguments.
-    pkihelper.process_command_line_arguments(argv)
+    parse.process_command_line_arguments(argv)
 
     # Enable 'pkispawn' logging.
     rv = 0
     if not config.pki_update_flag:
-        pki_deployment_begin = log.PKISPAWN_BEGIN_MESSAGE_2
-        pki_deployment_end = log.PKISPAWN_END_MESSAGE_2
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKISPAWN_LOG_PATH
-        config.pki_log_name = config.PKISPAWN_LOG_PREFIX +\
-                              config.pki_subsystem.lower() +\
-                              config.PKISPAWN_LOG_SUFFIX
+        if not config.pki_dry_run_flag:
+            config.pki_log_dir = config.pki_root_prefix +\
+                                 "/var/log"
+            config.pki_log_name = "pki" + "-" +\
+                                  config.pki_subsystem.lower() +\
+                                  "-" + "spawn" + "." +\
+                                  config.pki_timestamp + "." + "log"
+        else:
+            config.pki_log_dir = "/dev"
+            config.pki_log_name = "null"
         rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                           config.pki_log_name,
                                           config.pki_log_level,
                                           config.pki_console_log_level,
-                                          config.PKISPAWN_LOGGER)
+                                          "pkispawn")
     else:
-        pki_deployment_begin = log.PKIRESPAWN_BEGIN_MESSAGE_2
-        pki_deployment_end = log.PKIRESPAWN_END_MESSAGE_2
-        config.pki_log_dir = config.pki_root_prefix +\
-                             config.PKIRESPAWN_LOG_PATH
-        config.pki_log_name = config.PKIRESPAWN_LOG_PREFIX +\
-                              config.pki_subsystem.lower() +\
-                              config.PKIRESPAWN_LOG_SUFFIX
+        if not config.pki_dry_run_flag:
+            config.pki_log_dir = config.pki_root_prefix +\
+                                 "/var/log"
+            config.pki_log_name = "pki" + "-" +\
+                                  config.pki_subsystem.lower() +\
+                                  "-" + "respawn" + "." +\
+                                  config.pki_timestamp + "." + "log"
+        else:
+            config.pki_log_dir = "/dev"
+            config.pki_log_name = "null"
         rv = pkilogging.enable_pki_logger(config.pki_log_dir,
                                           config.pki_log_name,
                                           config.pki_log_level,
                                           config.pki_console_log_level,
-                                          config.PKIRESPAWN_LOGGER)
+                                          "pkirespawn")
     if rv != OSError:
         config.pki_log = rv
     else:
@@ -96,17 +106,24 @@ def main(argv):
         sys.exit(1)
 
     # Read the specified PKI configuration file.
-    rv = pkihelper.read_pki_configuration_file()
+    rv = parse.read_pki_configuration_file()
     if rv != 0:
-        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv)
+        config.pki_log.error(PKI_UNABLE_TO_PARSE_1, rv,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     else:
-        config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-        config.pki_log.debug(pp.pformat(config.pki_common_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-        config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+        config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                             extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Override PKI configuration file values with 'custom' command-line values.
     if not config.pki_instance_name is None:
@@ -121,39 +138,50 @@ def main(argv):
     if not config.pki_ajp_port is None:
         config.pki_web_server_dict['pki_ajp_port'] =\
             config.pki_ajp_port
-    config.pki_log.debug(log.PKI_DICTIONARY_COMMON)
-    config.pki_log.debug(pp.pformat(config.pki_common_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER)
-    config.pki_log.debug(pp.pformat(config.pki_web_server_dict))
-    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM)
-    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_COMMON,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_common_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_WEB_SERVER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_web_server_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(log.PKI_DICTIONARY_SUBSYSTEM,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_subsystem_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Combine the various sectional dictionaries into a PKI master dictionary
-    pkihelper.create_pki_master_dictionary()
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    parse.compose_pki_master_dictionary()
+    if not config.pki_update_flag:
+        config.pki_master_dict['pki_spawn_log'] = config.pki_log_dir + "/" +\
+                                                  config.pki_log_name
+    else:
+        config.pki_master_dict['pki_respawn_log'] = config.pki_log_dir + "/" +\
+                                                    config.pki_log_name
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
     # Install and configure the specified PKI subsystem.
-    pki_scriptlets_path = config.pki_root_prefix +\
-                          config.PKISPAWN_PATH +\
+    pki_scriptlets_path = "/usr/share/pki/deployment/spawn" +\
                           "/" + config.pki_subsystem.lower()
     if not os.path.exists(pki_scriptlets_path) or\
        not os.path.isdir(pki_scriptlets_path):
         config.pki_log.error(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
-                             pki_scriptlets_path)
+                             pki_scriptlets_path,
+                             extra=config.PKI_INDENTATION_LEVEL_0)
         sys.exit(1)
     pki_subsystem_scriptlets = os.listdir(pki_scriptlets_path)
     pki_subsystem_scriptlets.sort()
 
     # Process the various "scriptlets" for the specified PKI subsystem.
     rv = 0
-    config.pki_log.info(pki_deployment_begin,
-                        config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
     for pki_scriptlet in pki_subsystem_scriptlets:
-        scriptlet = __import__(config.PKI_DEPLOYMENT_SCRIPTLETS_MODULE +\
-                               '.' + pki_scriptlet[5:],
-                               fromlist = [pki_scriptlet[5:]])
+        scriptlet = __import__("pki.deployment" +\
+                               "." + pki_scriptlet[4:],
+                               fromlist = [pki_scriptlet[4:]])
         instance = scriptlet.PkiScriptlet()
         if not config.pki_update_flag:
             rv = instance.spawn()
@@ -161,14 +189,12 @@ def main(argv):
             rv = instance.respawn()
         if rv != 0:
             sys.exit(1)
-    config.pki_log.info(pki_deployment_end,
-                        config.pki_subsystem,
-                        config.pki_master_dict['pki_instance_name'])
-    config.pki_log.debug(log.PKI_DICTIONARY_MASTER)
-    config.pki_log.debug(pp.pformat(config.pki_master_dict))
+    config.pki_log.debug(log.PKI_DICTIONARY_MASTER,
+                         extra=config.PKI_INDENTATION_LEVEL_0)
+    config.pki_log.debug(pp.pformat(config.pki_master_dict),
+                         extra=config.PKI_INDENTATION_LEVEL_0)
 
 
 # PKI Deployment Entry Point
 if __name__ == "__main__":
     main(sys.argv)
-
diff --git a/base/deploy/src/scriptlets/configuration.py b/base/deploy/src/scriptlets/configuration.py
new file mode 100644
index 0000000..45b325c
--- /dev/null
+++ b/base/deploy/src/scriptlets/configuration.py
@@ -0,0 +1,52 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.CONFIGURATION_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        config.pki_log.info("NOT YET IMPLEMENTED",
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.CONFIGURATION_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        config.pki_log.info("NOT YET IMPLEMENTED",
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.CONFIGURATION_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        config.pki_log.info("NOT YET IMPLEMENTED",
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        return self.rv
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/deploy/src/scriptlets/finalization.py
new file mode 100644
index 0000000..6007326
--- /dev/null
+++ b/base/deploy/src/scriptlets/finalization.py
@@ -0,0 +1,109 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkihelper as util
+import pkimanifest as manifest
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.FINALIZATION_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # Save a copy of the configuration file used by this process
+        # (which may be used later by 'pkidestroy')
+        util.file.copy(config.pkideployment_cfg,
+                       master['pki_subsystem_registry_path'] +\
+                       "/" + config.PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE)
+        # Save a timestamped copy of the installation manifest file
+        filename = master['pki_root_prefix'] +\
+                   config.PKI_DEPLOYMENT_REGISTRY_ROOT + "/" +\
+                   master['pki_instance_name'] + "/" +\
+                   master['pki_subsystem'].lower() +"/" +\
+                   "spawn" + "_" + "manifest" + "." +\
+                   master['pki_timestamp'] + "." + "csv"
+        config.pki_log.info(log.PKI_MANIFEST_MESSAGE_1, filename,
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        # for record in manifest.database:
+        #     print tuple(record)
+        if not config.pki_dry_run_flag:
+            manifest.file.register(filename)
+            manifest.file.write()
+            util.file.modify(filename, silent=True)
+        # Log final process messages
+        config.pki_log.info(log.PKISPAWN_END_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        if not config.pki_dry_run_flag:
+            util.file.modify(master['pki_spawn_log'], silent=True)
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.FINALIZATION_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # Save a copy of the configuration file used by this process
+        # (which may be used later by 'pkidestroy')
+        util.file.copy(config.pkideployment_cfg,
+                       master['pki_subsystem_registry_path'] +\
+                       "/" + config.PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE,
+                       overwrite_flag=True)
+        # Save a timestamped copy of the updated manifest file
+        filename = master['pki_root_prefix'] +\
+                   config.PKI_DEPLOYMENT_REGISTRY_ROOT + "/" +\
+                   master['pki_instance_name'] + "/" +\
+                   master['pki_subsystem'].lower() +"/" +\
+                   "respawn" + "_" + "manifest" + "." +\
+                   master['pki_timestamp'] + "." + "csv"
+        config.pki_log.info(log.PKI_MANIFEST_MESSAGE_1, filename,
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        # for record in manifest.database:
+        #     print tuple(record)
+        if not config.pki_dry_run_flag:
+            manifest.file.register(filename)
+            manifest.file.write()
+            util.file.modify(filename, silent=True)
+        # Log final process messages
+        config.pki_log.info(log.PKIRESPAWN_END_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        if not config.pki_dry_run_flag:
+            util.file.modify(master['pki_respawn_log'], silent=True)
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.FINALIZATION_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        config.pki_log.info(log.PKIDESTROY_END_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        if not config.pki_dry_run_flag:
+            util.file.modify(master['pki_destroy_log'], silent=True)
+        return self.rv
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/deploy/src/scriptlets/initialization.py
new file mode 100644
index 0000000..67c9325
--- /dev/null
+++ b/base/deploy/src/scriptlets/initialization.py
@@ -0,0 +1,68 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.PKISPAWN_BEGIN_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.info(log.INITIALIZATION_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish 'uid' and 'gid'
+        util.identity.set_uid(master['pki_user'])
+        util.identity.set_gid(master['pki_group'])
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.PKIRESPAWN_BEGIN_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.info(log.INITIALIZATION_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish 'uid' and 'gid'
+        util.identity.set_uid(master['pki_user'])
+        util.identity.set_gid(master['pki_group'])
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.PKIDESTROY_BEGIN_MESSAGE_2,
+                            master['pki_subsystem'],
+                            master['pki_instance_name'],
+                            extra=config.PKI_INDENTATION_LEVEL_0)
+        config.pki_log.info(log.INITIALIZATION_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish 'uid' and 'gid'
+        util.identity.set_uid(master['pki_user'])
+        util.identity.set_gid(master['pki_group'])
+        return self.rv
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
new file mode 100644
index 0000000..38234f4
--- /dev/null
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -0,0 +1,97 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.INSTANCE_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # establish instance base
+        util.directory.create(master['pki_path'])
+        util.directory.create(master['pki_instance_path'])
+        # establish instance logs
+        util.directory.create(master['pki_log_path'])
+        util.directory.create(master['pki_instance_log_path'])
+        # establish instance configuration
+        if master['pki_configuration_path'] !=\
+           config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.create(master['pki_configuration_path'])
+        util.directory.create(master['pki_instance_configuration_path'])
+        # establish instance registry
+        util.directory.create(master['pki_registry_path'])
+        util.directory.create(master['pki_instance_registry_path'])
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.INSTANCE_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # update instance base
+        util.directory.modify(master['pki_path'])
+        util.directory.modify(master['pki_instance_path'])
+        # update instance logs
+        util.directory.modify(master['pki_log_path'])
+        util.directory.modify(master['pki_instance_log_path'])
+        # update instance configuration
+        if master['pki_configuration_path'] !=\
+           config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.modify(master['pki_configuration_path'])
+        util.directory.modify(master['pki_instance_configuration_path'])
+        # update instance registry
+        util.directory.modify(master['pki_registry_path'])
+        util.directory.modify(master['pki_instance_registry_path'])
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.INSTANCE_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        # remove instance base
+        if util.directory.is_empty(master['pki_instance_path']):
+            util.directory.delete(master['pki_instance_path'])
+        if util.directory.is_empty(master['pki_path']):
+            util.directory.delete(master['pki_path'])
+        # remove instance logs
+        if util.directory.is_empty(master['pki_instance_log_path']):
+            util.directory.delete(master['pki_instance_log_path'])
+        if util.directory.is_empty(master['pki_log_path']):
+            util.directory.delete(master['pki_log_path'])
+        # remove instance configuration
+        if util.directory.is_empty(master['pki_instance_configuration_path']):
+            util.directory.delete(master['pki_instance_configuration_path'])
+        if util.directory.is_empty(master['pki_configuration_path']) and\
+           master['pki_configuration_path'] !=\
+           config.PKI_SHARED_CONFIGURATION_ROOT:
+            util.directory.delete(master['pki_configuration_path'])
+        # remove instance registry
+        if util.directory.is_empty(master['pki_instance_registry_path']):
+            util.directory.delete(master['pki_instance_registry_path'])
+        if util.directory.is_empty(master['pki_registry_path']):
+            util.directory.delete(master['pki_registry_path'])
+        return self.rv
diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index 7d676c0..505bfc0 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -15,7 +15,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 #
-# Copyright (C) 2011 Red Hat, Inc.
+# Copyright (C) 2012 Red Hat, Inc.
 # All rights reserved.
 #
 
@@ -24,51 +24,50 @@ import logging
 
 
 # PKI Deployment Constants
-PKI_DEPLOYMENT_PATH = "/usr/share/pki/deployment"
-PKI_DEPLOYMENT_CONFIG_PATH = PKI_DEPLOYMENT_PATH + "/" + "config"
-PKI_DEPLOYMENT_SCRIPTLETS_MODULE = "pki.deployment"
-PKI_DEPLOYMENT_VERBOSITY=\
-"VERBOSITY FLAGS    CONSOLE MESSAGE LEVEL       LOG MESSAGE LEVEL\n"\
-"=======================================================================\n"\
-"  NONE             error|warning               error|warning|info\n"\
-"  -v               error|warning|info          error|warning|info\n"\
-"  -vv              error|warning|info          error|warning|info|debug\n"\
-"  -vvv             error|warning|info|debug    error|warning|info|debug\n"\
-" "
 PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_EXE_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS = 00660
+PKI_DEPLOYMENT_DEFAULT_SGID_DIR_PERMISSIONS = 02770
+PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS = 00777
 PKI_DEPLOYMENT_DEFAULT_UMASK = 00002
 
-PKIDESTROY_PATH = PKI_DEPLOYMENT_PATH + "/" + "destroy"
-PKIDESTROY_LOG_PATH = "/var/log"
-PKIDESTROY_LOG_PREFIX = "pki-"
-PKIDESTROY_LOG_SUFFIX = "-destroy.log"
-PKIDESTROY_LOGGER = "pkidestroy"
-
-PKIRESPAWN_PATH = PKI_DEPLOYMENT_PATH + "/" + "spawn"
-PKIRESPAWN_LOG_PATH = "/var/log"
-PKIRESPAWN_LOG_PREFIX = "pki-"
-PKIRESPAWN_LOG_SUFFIX = "-respawn.log"
-PKIRESPAWN_LOGGER = "pkirespawn"
-
-PKISPAWN_PATH = PKI_DEPLOYMENT_PATH + "/" + "spawn"
-PKISPAWN_LOG_PATH = "/var/log"
-PKISPAWN_LOG_PREFIX = "pki-"
-PKISPAWN_LOG_SUFFIX = "-spawn.log"
-PKISPAWN_LOGGER = "pkispawn"
-
-PKI_SECURITY_DATABASE_DIR = "alias"
 PKI_SUBSYSTEMS = ["CA","KRA","OCSP","RA","TKS","TPS"]
+PKI_SIGNED_AUDIT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS","TPS"]
 PKI_APACHE_SUBSYSTEMS = ["RA","TPS"]
 PKI_TOMCAT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS"]
 
+PKI_INDENTATION_LEVEL_0 = {'indent' : ''}
+PKI_INDENTATION_LEVEL_1 = {'indent' : '... '}
+PKI_INDENTATION_LEVEL_2 = {'indent' : '....... '}
+PKI_INDENTATION_LEVEL_3 = {'indent' : '........... '}
+PKI_INDENTATION_LEVEL_4 = {'indent' : '............... '}
+
+# NOTE:  Well-known 'registry root', default 'instance', and default
+#        'configuration file' names MUST be created in order to potentially
+#        obtain an instance-specific configuration file
+#        (presuming one has not been specified during command-line parsing)
+#        because command-line parsing happens prior to reading any
+#        configuration files.  Although the 'registry root' MUST remain fixed,
+#        the default 'instance' name may be overridden by the value specified
+#        in the configuration file (the value in the default configuration file
+#        should always match the 'default' instance name specified below).
+PKI_DEPLOYMENT_REGISTRY_ROOT = "/etc/sysconfig/pki"
+PKI_DEPLOYMENT_DEFAULT_INSTANCE_NAME = "instance"
+PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE = "pkideployment.cfg"
+
+# NOTE: Top-level "/etc/pki" is owned by the "filesystem" package!
+PKI_SHARED_CONFIGURATION_ROOT = "/etc/pki"
+
+
+# PKI Deployment Global Variables
+pki_timestamp = None
+
 
 # PKI Deployment "Mandatory" Command-Line Variables
 pki_subsystem = None
 
 # PKI Deployment "Optional" Command-Line Variables
-pkideployment_cfg = PKI_DEPLOYMENT_CONFIG_PATH + "/" + "pkideployment.cfg"
+pkideployment_cfg = "/usr/share/pki/deployment/config/pkideployment.cfg"
 pki_dry_run_flag = False
 pki_root_prefix = None
 pki_update_flag = False
@@ -93,4 +92,3 @@ pki_common_dict = None
 pki_web_server_dict = None
 pki_subsystem_dict = None
 pki_master_dict = None
-
